// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "BaseGadgetTutorial.h"
#include "EndlessVendetta/GadgetSystem/GadgetManager.h"
#include "VisionLinkTutorial.generated.h"

UCLASS()
class ENDLESSVENDETTA_API AVisionLinkTutorial : public ABaseGadgetTutorial
{
	GENERATED_BODY()

	AGadgetManager* GadgetManager;

	bool PlayerInTutorialZone = false;
	bool PlayerWasInTutZone = false;

	void BeginPlay() override;

	void Tick(float DeltaSeconds) override;

protected:
	UPROPERTY(EditDefaultsOnly)
	FString GoToAreaWaypointDesc;
	UPROPERTY(EditDefaultsOnly)
	FString LookAtTargetWaypointDesc;
	UPROPERTY(EditDefaultsOnly)
	FString ResultWaypointDesc;
	
	UPROPERTY(BlueprintReadWrite)
	FVector GoToAreaWaypointLoc;
	UPROPERTY(BlueprintReadWrite)
	FVector LookAtTargetWaypointLoc;
	UPROPERTY(BlueprintReadWrite)
	FVector ResultWaypointLoc;

	UPROPERTY(BlueprintReadWrite)
	FVector TargetLoc;
	
	UFUNCTION(BlueprintCallable)
	void PlayerEnteredTutorialZone()
	{
		PlayerInTutorialZone = true;
	}
	UFUNCTION(BlueprintCallable)
	void PlayerLeftTutorialZone()
	{
		PlayerInTutorialZone = false;
	}
};
