// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Blueprint/UserWidget.h"
#include "Components/CanvasPanelSlot.h"
#include "Components/CanvasPanel.h"
#include "Components/Image.h"
#include "MiniWaypoint.generated.h"

/**
 * 
 */
UCLASS()
class ENDLESSVENDETTA_API UMiniWaypoint : public UUserWidget
{
	GENERATED_BODY()
	
	void NativeTick(const FGeometry& MyGeometry, float InDeltaTime) override;

	UCanvasPanelSlot* IconCanvasPanelSlot;
	UImage* ArrowImage;

protected:	
	UFUNCTION(BlueprintCallable)
	void SetIconPanelSlot(UCanvasPanel* IconParent, UImage* ArrowImageComp);

public:
	FVector WorldLoc = FVector(0, 0, 0);
	APlayerController* PlayerController;
	
	UFUNCTION(BlueprintImplementableEvent)
	void UpdateVisibility(bool IsVisible);

	UFUNCTION(BlueprintImplementableEvent)
	void SetIcon(UTexture2D* Icon);
	
};
